## netpbm-free 11.12.00

=== Makefile ===
# The Netpbm make files exploit features of GNU Make that other Makes
# do not have.  Because it is a common mistake for users to try to build
# Netpbm with a different Make, we have this make file that does nothing
# but tell the user to use GNU Make.

# If the user were using GNU Make now, this file would not get used because
# GNU Make uses a make file named "GNUmakefile" in preference to "Makefile"
# if it exists.  Netpbm is shipped with a "GNUmakefile".

default: all

all merge install clean dep:
	@echo "You must use GNU Make to build Netpbm.  You are running some "
	@echo "other Make.  GNU Make may be installed on your system with "
	@echo "the name 'gmake'.  If not, see http://www.gnu.org/software ."
	@echo
	false

=== analyzer/Makefile ===
ifeq ($(SRCDIR)x,x)
  SRCDIR = $(CURDIR)/..
  BUILDDIR = $(SRCDIR)
endif
SUBDIR = analyzer
VPATH=.:$(SRCDIR)/$(SUBDIR)

include $(BUILDDIR)/config.mk

# We tend to separate out the build targets so that we don't have
# any more dependencies for a given target than it really needs.
# That way, if there is a problem with a dependency, we can still
# successfully build all the stuff that doesn't depend upon it.
# This package is so big, it's useful even when some parts won't 
# build.

PORTBINARIES = \
  pamfind \
  pamgetcolor \
  pamfile \
  pammosaicknit \
  pamslice \
  pamsumm \
  pamtable \
  pamtilt \
  pbmminkowski \
  pgmhist \
  pnmhistmap \
  ppmhist \
  pgmminkowski \

MATHBINARIES = \
  pamsharpmap \
  pamsharpness \
  pgmtexture \
  pnmpsnr \

BINARIES = $(PORTBINARIES) $(MATHBINARIES)
SCRIPT =

OBJECTS = $(BINARIES:%=%.o)

# We don't include programs that have special library dependencies in the
# merge scheme, because we don't want those dependencies to prevent us
# from building all the other programs.

MERGEBINARIES = $(BINARIES)
MERGE_OBJECTS = $(MERGEBINARIES:%=%.o2)

HAVE_MERGE_COMPAT=YES

.PHONY: all
all: $(BINARIES)

include $(SRCDIR)/common.mk

install.bin install.merge: install.bin.local
.PHONY: install.bin.local
install.bin.local: $(PKGDIR)/bin
# Remember that $(SYMLINK) might just be a copy command.
	cd $(PKGDIR)/bin ; \
	$(SYMLINK) pamslice$(EXE) pgmslice$(EXE)
	cd $(PKGDIR)/bin ; \
	$(SYMLINK) pamfile$(EXE) pnmfile$(EXE)

mergecomptrylist:
	cat /dev/null >$@
	echo "TRY(\"pgmslice\", main_pamslice);" >>$@
	echo "TRY(\"pnmfile\",  main_pamfile);"  >>$@

FORCE:

=== buildtools/Makefile ===
ifeq ($(SRCDIR)x,x)
  SRCDIR = $(CURDIR)/..
  BUILDDIR = $(SRCDIR)
endif
SUBDIR = buildtools
VPATH = .:$(SRCDIR)/$(SUBDIR)
include $(BUILDDIR)/config.mk

MERGE_OBJECTS =

BUILDPROGS = libopt typegen endiangen

all: $(BUILDPROGS)

OMIT_BUILDTOOL_RULE = 1
include $(SRCDIR)/common.mk

ifdef DLLVER
STRIP_DLL_VERSION=-DDLLVERSTR="\"$(DLLVER)\""
endif

ifeq ($(LINKER_CAN_DO_EXPLICIT_LIBRARY),Y)
EXPLICIT=-DEXPLICIT
endif

libopt.o: libopt.c
	$(CC_FOR_BUILD) -c -o $@ $(CFLAGS_FOR_BUILD) \
	  -DSHLIBPREFIXLIST="\"$(SHLIBPREFIXLIST)\"" \
	  $(STRIP_DLL_VERSION) $(EXPLICIT) \
	  $(CFLAGS_PERSONAL) $(CFLAGS) $(CADD) \
	  $<

typegen.o endiangen.o:%.o:%.c
	$(CC_FOR_BUILD) -c -o $@ $(CFLAGS_FOR_BUILD) $<

# genfontc is strange because it isn't really a build tool; it's a development
# tool.  And it uses Netpbm.  So we don't even build it by default and the
# developer who builds it explicitly may have to be careful.
genfontc.o:%.o:%.c importinc
	$(CC_FOR_BUILD) -c -o $@ $(CFLAGS_FOR_BUILD) \
	  $(NETPBM_INCLUDES) \
	  $<
genfontc:%:%.o $(NETPBMLIB)
	$(LD_FOR_BUILD) -o $@ $(LDFLAGS_FOR_BUILD)  $< $(NETPBMLIB)

$(BUILDPROGS):%:%.o
	$(LD_FOR_BUILD) -o $@ $(LDFLAGS_FOR_BUILD) $<

distclean clean: cleanlocal
.PHONY: cleanlocal
cleanlocal:
	rm -f $(BUILDPROGS) genfontc

=== converter/Makefile ===
ifeq ($(SRCDIR)x,x)
  SRCDIR = $(CURDIR)/..
  BUILDDIR = $(SRCDIR)
endif
SUBDIR = converter
VPATH=.:$(SRCDIR)/$(SUBDIR)

include $(BUILDDIR)/config.mk

SUBDIRS = pbm pgm ppm other

all: $(SUBDIRS:%=%/all)

SCRIPTS = 
BINARIES =

include $(SRCDIR)/common.mk

=== editor/Makefile ===
ifeq ($(SRCDIR)x,x)
  SRCDIR = $(CURDIR)/..
  BUILDDIR = $(SRCDIR)
endif
SUBDIR = editor
VPATH=.:$(SRCDIR)/$(SUBDIR)

include $(BUILDDIR)/config.mk

SUBDIRS = pamflip specialty

# We tend to separate out the build targets so that we don't have
# any more dependencies for a given target than it really needs.
# That way, if there is a problem with a dependency, we can still
# successfully build all the stuff that doesn't depend upon it.
# This package is so big, it's useful even when some parts won't 
# build.

PORTBINARIES = pamaddnoise pamaltsat pambackground pambrighten \
	       pamcat pamcomp pamcut \
	       pamdice pamditherbw pamedge pamenlarge \
	       pamfunc pamhomography pamhue pamlevels \
	       pammasksharpen pammixmulti \
	       pamperspective pamrecolor pamrestack pamrubber \
	       pamscale pamshuffle pamsistoaglyph pamstretch pamthreshold \
	       pamundice pamwipeout \
	       pbmclean pbmmask pbmpscale pbmreduce \
	       pgmdeshadow pgmenhance \
	       pgmmedian \
	       pnmalias pnmconvol pnmcrop \
	       pnmgamma \
	       pnmhisteq pnminvert pnmmontage \
	       pnmnlfilt pnmnorm pnmpad pnmpaste \
	       pnmremap pnmrotate \
	       pnmscalefixed pnmshear pnmsmooth pnmstitch pnmtile \
	       ppmchange ppmcolormask \
	       ppmdim ppmdist ppmdither ppmdraw \
	       ppmflash ppmlabel ppmmix \

# We don't include programs that have special library dependencies in the
# merge scheme, because we don't want those dependencies to prevent us
# from building all the other programs.

NOMERGEBINARIES = 
MERGEBINARIES = $(PORTBINARIES)

BINARIES = $(MERGEBINARIES) $(NOMERGEBINARIES)
SCRIPTS = ppmbrighten pnmflip ppmfade ppmquant ppmshadow \
	  pamstretch-gen pnmmargin pnmquant pnmquantall 

OBJECTS = $(BINARIES:%=%.o)

MERGE_OBJECTS = $(MERGEBINARIES:%=%.o2)

HAVE_MERGE_COMPAT=YES

.PHONY: all
all: $(BINARIES) $(SUBDIRS:%=%/all)

include $(SRCDIR)/common.mk

install.bin install.merge: install.bin.local

.PHONY: install.bin.local
install.bin.local: $(PKGDIR)/bin
# Remember that $(SYMLINK) might just be a copy command.

# In December 2001, pamstretch replaced pnminterp and pamstretch-getn
# replaced pnminterp-gen
	cd $(PKGDIR)/bin ; \
	rm -f pnminterp$(EXE); \
	$(SYMLINK) pamstretch$(EXE) pnminterp$(EXE)
	cd $(PKGDIR)/bin ; \
	rm -f pnminterp-gen$(EXE); \
	$(SYMLINK) pamstretch-gen$(EXE) pnminterp-gen$(EXE)
# In March 2002, pnmnorm replaced ppmnorm and pgmnorm
	cd $(PKGDIR)/bin ; \
	rm -f ppmnorm$(EXE) ; \
	$(SYMLINK) pnmnorm$(EXE) ppmnorm$(EXE)
	cd $(PKGDIR)/bin ; \
	rm -f pgmnorm$(EXE) ; \
	$(SYMLINK) pnmnorm$(EXE) pgmnorm$(EXE)
# In March 2003, pamedge replaced pgmedge
	cd $(PKGDIR)/bin ; \
	rm -f pgmedge$(EXE) ; \
	$(SYMLINK) pamedge$(EXE) pgmedge$(EXE)
# In October 2004, pamenlarge replaced pnmenlarge
	cd $(PKGDIR)/bin ; \
	rm -f pnmenlarge$(EXE) ; \
	$(SYMLINK) pamenlarge$(EXE) pnmenlarge$(EXE)
# In March 2009, pamcut replaced pnmcut (but pamcut is much older -- pnmcut
# was obsoleted by pamcut long before this).
	cd $(PKGDIR)/bin ; \
	rm -f pnmcut$(EXE) ; \
	$(SYMLINK) pamcut$(EXE) pnmcut$(EXE)
# In March 2009, pamscale replaced pnmscale (but pamscale is much older --
# pnmscale was obsoleted by pamscale long before this).
	cd $(PKGDIR)/bin ; \
	rm -f pnmscale$(EXE) ; \
	$(SYMLINK) pamscale$(EXE) pnmscale$(EXE)
# In March 2012, pnmquantall replaced ppmquantall
	cd $(PKGDIR)/bin ; \
	rm -f ppmquantall$(EXE) ; \
	$(SYMLINK) pnmquantall$(EXE) ppmquantall$(EXE)
# In August 2014, pamcomp replaced pnmcomp
	cd $(PKGDIR)/bin ; \
	rm -f pnmcomp$(EXE) ; \
	$(SYMLINK) pamcomp$(EXE) pnmcomp$(EXE)
# In August 2022, pamcat replaced pnmcat
	cd $(PKGDIR)/bin ; \
	rm -f pnmcat$(EXE) ; \
	$(SYMLINK) pamcat$(EXE) pnmcat$(EXE)

mergecomptrylist:
	cat /dev/null >$@
	echo "TRY(\"pnminterp\",  main_pamstretch);" >>$@
	echo "TRY(\"pgmnorm\",    main_pnmnorm);"    >>$@
	echo "TRY(\"ppmnorm\",    main_pnmnorm);"    >>$@
	echo "TRY(\"pgmedge\",    main_pamedge);"    >>$@
	echo "TRY(\"pnmenlarge\", main_pamenlarge);" >>$@
	echo "TRY(\"pnmcut\",     main_pamcut);"     >>$@
	echo "TRY(\"pnmscale\",   main_pamscale);"   >>$@
	echo "TRY(\"pnmcomp\",    main_pamcomp);"    >>$@
	echo "TRY(\"pnmcat\",     main_pamcat);"     >>$@

=== icon/Makefile ===
ifeq ($(SRCDIR)x,x)
  SRCDIR = $(CURDIR)/..
  BUILDDIR = $(SRCDIR)
endif
SUBDIR = buildtools
VPATH = .:$(SRCDIR)/$(SUBDIR)
include $(BUILDDIR)/config.mk

.PHONY: default
default: netpbm.o

# We must not attempt to build netpbm.o if the build system does not
# have 'windres', so our all list is empty.
.PHONY: all
all:

include $(SRCDIR)/common.mk

%.ico:%.ppm
	ppmtowinicon $< >$@

%.o:%.ico
	echo "id ICON \"$<\"" >rc
	$(WINDRES) --input-format rc --input rc --output-format coff \
	   --output $@
	rm rc

distclean clean: cleanlocal
.PHONY: cleanlocal
cleanlocal:
	rm -f rc

=== lib/Makefile ===
ifeq ($(SRCDIR)x,x)
  SRCDIR = $(CURDIR)/..
  BUILDDIR = $(SRCDIR)
endif
SUBDIR = lib
VPATH=.:$(SRCDIR)/$(SUBDIR)
DLLTOOL=dlltool
include $(BUILDDIR)/config.mk

ifeq ($(NETPBMLIBTYPE),unixstatic)
LIBNETPBM = libnetpbm.$(STATICLIBSUFFIX)
else
LIBNETPBM = $(NETPBMSHLIBPREFIX)netpbm$(DLLVER).$(NETPBMLIBSUFFIX)
endif

ifeq ($(STATICLIB_TOO),Y)
EXTRA_STATICLIB = libnetpbm.$(STATICLIBSUFFIX)
else
EXTRA_STATICLIB =
endif

ifeq ($(DONT_HAVE_PROCESS_MGMT),Y)
  LIBSYSTEM = libsystem_dummy.o
else
  LIBSYSTEM = libsystem.o
endif

LIBOBJECTS = libpm.o pmfileio.o fileio.o colorname.o \
	libpamd.o \
	libpbm1.o libpbm2.o libpbm3.o \
	libpbmfont0.o libpbmfont1.o libpbmfont2.o \
	pbmfontdata0.o pbmfontdata1.o pbmfontdata2.o \
	libpgm1.o libpgm2.o \
	libppm1.o libppm2.o libppmcmap.o libppmcolor.o libppmfuzzy.o \
	libppmd.o ppmdfont.o standardppmdfont.o path.o \
	libpnm1.o libpnm2.o libpnm3.o \
	libpam.o libpamread.o libpamwrite.o \
	libpamn.o libpammap.o libpamcolor.o \
	$(LIBSYSTEM) \

# Library objects to be linked but not built by common.mk:
LIBOBJECTS_X = \
  util/bitio.o \
  util/filename.o \
  util/io.o \
  util/mallocvar.o \
  util/matrix.o \
  util/nsleep.o \
  util/nstring.o \
  util/rand.o \
  util/randsysrand.o \
  util/randsysrandom.o \
  util/randmersenne.o \
  util/runlength.o \
  util/shhopt.o \
  util/token.o \
  util/vasprintf.o \

MANUALS3 = libnetpbm
MANUALS5 = pbm pgm ppm pnm pam

INTERFACE_HEADERS = colorname.h \
	pam.h pamdraw.h pammap.h pbm.h pbmfont.h pbmfontdata.h \
	pgm.h pm.h pm_gamma.h pm_system.h pnm.h \
	ppm.h ppmcmap.h ppmdfont.h ppmdraw.h \
	util/mallocvar.h util/runlength.h util/shhopt.h \

DATAFILES = rgb.txt

.PHONY: all
all: libnetpbm extra_staticlib

SUBDIRS = util
SCRIPTS = 
BINARIES = 

OMIT_LIBRARY_RULE = 1
ALL_INTERNAL_HEADER_FILES_ARE_QUALIFIED = Y
include $(SRCDIR)/common.mk

# The following must go after common.mk because $(LIBNETPBM) may 
# contain a reference to $(NETPBM_MAJOR_RELEASE).
.PHONY: libnetpbm
libnetpbm: $(LIBNETPBM)

.PHONY: extra_staticlib
extra_staticlib: $(EXTRA_STATICLIB)

#----------------------------------------------------------------------------
# Following are rules for building shared libraries.
# Note that the user may specify a shared library as his "main" library
# type, but request a static library in addition.
#----------------------------------------------------------------------------

$(LIBOBJECTS): CFLAGS_TARGET=$(CFLAGS_SHLIB)

libpbm3.o: CFLAGS_TARGET+=$(CFLAGS_SSE)

# libsystem_dummy.o is in the following rule because we like to compile it
# even when it's not part of the library, just for a test.

$(LIBOBJECTS) libsystem_dummy.o: %.o: %.c importinc
	$(CC) -c $(INCLUDES) $(CFLAGS_ALL) -o $@ $<

# The major number increases when there is a non-backward-compatible change
# to the library at the binary level, meaning any client of the library needs
# to keep using the old library until it has been recompiled for the new
# library.  We try very hard never to lose backward compatibility at the
# source level, which would mean the client source code has to be modified
# before it can use the new library.
#
# The major number might seem like it corresponds to the major version number
# of Netpbm, but it does not.  It is independent.
#
# Adding functions is backward compatible, so does not require a major number
# change.
#
# The minor number must always increase within a major number.
#
# It is convenient to have the minor number equal to the minor version number
# of Netpbm, but when we changed the Netpbm major version number from 10 to 11
# just to keep the minor version number 2 digits, we had to continue
# increasing the library minor number, so we went to 100 + minor version
# number.  If we ever increase the library major number to 12, we can go back
# to using the minor version number for the library minor number.

MAJ := 11
$(eval MIN:=$(shell echo $$((100+$(NETPBM_MINOR_RELEASE)))))

SONAME = libnetpbm.$(NETPBMLIBSUFFIX).$(MAJ)

ifeq ($(NETPBMLIBTYPE),irixshared)
# The libxxx.so link is needed to link the executables.
libnetpbm.$(NETPBMLIBSUFFIX): $(SONAME)
	rm -f $@
	$(SYMLINK) $< $@

PERLPROG = print "sgi$(MAJ)." . join(":sgi$(MAJ) . ", (0..$(MIN))) . "\n"

$(SONAME): \
    $(LIBOBJECTS) $(LIBOBJECTS_X) 
	$(LD) $(LDSHLIB) $(LDFLAGS) -o $@ $(LIBOBJECTS) $(LIBOBJECTS_X) \
          -lc \
	  -soname libnetpbm.$(NETPBMLIBSUFFIX) \
	  -set_version $(shell perl -e '$(PERLPROG)') \
	  $(LADD)
endif

ifeq ($(NETPBMLIBTYPE),unixshared)
# The libxxx.so link is needed to link the executables.
libnetpbm.$(NETPBMLIBSUFFIX): $(SONAME)
	rm -f $@
	$(SYMLINK) $< $@
# The $(SONAME) link is needed only to test the programs without
# installing the libraries (in that case, you also need to direct the 
# dynamic linker to the source directories, e.g. set LD_LIBRARY_PATH).
$(SONAME): libnetpbm.$(NETPBMLIBSUFFIX).$(MAJ).$(MIN)
	rm -f $@
	$(SYMLINK) $< $@
libnetpbm.$(NETPBMLIBSUFFIX).$(MAJ).$(MIN): $(LIBOBJECTS) $(LIBOBJECTS_X)
	$(LD) $(LDSHLIB) $(LDFLAGS) -o $@ $(LIBOBJECTS) $(LIBOBJECTS_X) \
          $(SHLIB_CLIB) -lm $(LADD)
endif

ifeq ($(NETPBMLIBTYPE),dll)
ifeq ($(STATICLIB_TOO),Y)
$(NETPBMSHLIBPREFIX)netpbm$(DLLVER).dll: $(LIBOBJECTS) $(LIBOBJECTS_X) libnetpbm.$(STATICLIBSUFFIX)
else
$(NETPBMSHLIBPREFIX)netpbm$(DLLVER).dll: $(LIBOBJECTS) $(LIBOBJECTS_X)
endif
	$(LD) $(LDSHLIB) $(LDFLAGS) -Wl,--export-all-symbols \
            -Wl,-soname,$(NETPBMSHLIBPREFIX)netpbm$(DLLVER).dll \
	    -Wl,--output-def,$(NETPBMSHLIBPREFIX)netpbm$(DLLVER).def \
            -Wl,--out-implib,libnetpbm.dll.a -o $@ \
            $(LIBOBJECTS) $(LIBOBJECTS_X) $(LDLIBS) $(LADD) 
endif

ifeq ($(NETPBMLIBTYPE),dylib)
libnetpbm.dylib: libnetpbm.$(MAJ).dylib
	rm -f $@
	$(SYMLINK) $< $@

libnetpbm.$(MAJ).dylib: libnetpbm.$(MAJ).$(MIN).dylib
	rm -f $@
	$(SYMLINK) $< $@

libnetpbm.$(MAJ).$(MIN).dylib: $(LIBOBJECTS) $(LIBOBJECTS_X) 
	$(LD) $(LDSHLIB) $(LDFLAGS) -o $@ $(LIBOBJECTS) $(LIBOBJECTS_X) \
           -lc $(LADD)
endif

#--------------------------------------------------------------------------
# The rule for building a static library is below (if needed).  This is
# tricky because the user can be building the static library as his main
# library or in addition to some other kind of main library.  In fact,
# he may have specified it both as the main library type and an 
# additional library type.  In that case, NETPBMLIBSUFFIX and 
# STATICLIBSUFFIX are redundant -- we hope they're the same.
# 
# We must not include a rule for static libraries if he doesn't want us
# to build any.  The library name we come up with might conflict with 
# the name of the library he actually is building.  In fact, in that case
# STATICLIB_SUFFIX may just be arbitrary.
#-----------------------------------------------------------------------------
ifeq ($(NETPBMLIBTYPE),unixstatic)
  BUILD_STATICLIB = Y
else
  ifeq ($(STATICLIB_TOO),Y)
    BUILD_STATICLIB = Y
  else
    BUILD_STATICLIB = N
  endif
endif

ifeq ($(BUILD_STATICLIB),Y)
libnetpbm.$(STATICLIBSUFFIX): $(LIBOBJECTS) $(LIBOBJECTS_X)
	-rm -f $@
	$(AR) rc $@ $(LIBOBJECTS) $(LIBOBJECTS_X)
	-$(RANLIB) $@
endif


# To avoid major hassles with having ppmdcfont available here, we just ship a
# pre-made standardppmfont.c, so this rule will not normally be used.  Though
# standardppmdfont.c depends upon standard.ppmdfont, we don't declare that
# here because when the user creates the source tree, the modification time of
# standard.ppmdfont may end up later than that of standardppmdfont.c, which
# would make the build want to rebuild it.
standardppmdfont.c:
	ppmdcfont <standard.ppmdfont >$@

# Note that we create a new compile.h only for the first make after a
# make clean.  This is good enough.  We used to do stamp-date for
# every build of "all" from the Netpbm top directory, but nowhere
# else, so it was really sloppy.

compile.h:
	$(SRCDIR)/buildtools/stamp-date >$@ || rm $@

$(LIBOBJECTS_X): FORCE
	@if [ ! -d $(dir $@) ] ; then mkdir $(dir $@) ; fi
	$(MAKE) -C $(dir $@) -f $(SRCDIR)/$(SUBDIR)/$(dir $@)Makefile \
		SRCDIR=$(SRCDIR) BUILDDIR=$(BUILDDIR) $(notdir $@) 

libpm.o: compile.h

# Install a shared library
#
.PHONY: install.lib
ifeq ($(NETPBMLIBTYPE),unixshared)
# install a Unix-style shared library
install.lib: $(PKGDIR)/lib $(PKGDIR)/sharedlink
	cd $(PKGDIR)/lib ; rm -f libnetpbm.$(NETPBMLIBSUFFIX).$(MAJ).*
	$(INSTALL) -c -m $(INSTALL_PERM_LIBD) \
	  libnetpbm.$(NETPBMLIBSUFFIX).$(MAJ).$(MIN)  $(PKGDIR)/lib/
	cd $(PKGDIR)/lib/ ; \
          rm -f libnetpbm.$(NETPBMLIBSUFFIX).$(MAJ); \
          $(SYMLINK) libnetpbm.$(NETPBMLIBSUFFIX).$(MAJ).$(MIN) $(SONAME)
endif
ifeq ($(NETPBMLIBTYPE),dll)
#install a Windows DLL shared library
#Note that unlike Unix libraries, a Windows DLL must go into a directory
#that is in the PATH, so we use bin/ instead of lib/
install.lib: $(PKGDIR)/bin
	( cd $(PKGDIR)/bin ; rm -f $(NETPBMSHLIBPREFIX)netpbm$(DLLVER).dll )
	$(INSTALL) -c $(STRIPFLAG) -m $(INSTALL_PERM_LIBD) \
          $(NETPBMSHLIBPREFIX)netpbm$(DLLVER).dll $(PKGDIR)/bin/
endif
ifeq ($(NETPBMLIBTYPE),dylib)
# install a Darwin-style shared library
install.lib: $(PKGDIR)/lib
	cd $(PKGDIR)/lib ; rm -f libnetpbm.*.dylib
	$(INSTALL) -c -m $(INSTALL_PERM_LIBD) libnetpbm.$(MAJ).$(MIN).dylib \
	   $(PKGDIR)/lib
	cd $(PKGDIR)/lib ; \
          rm -f libnetpbm.$(MAJ).dylib; \
          $(SYMLINK) libnetpbm.$(MAJ).$(MIN).dylib libnetpbm.$(MAJ).dylib
endif

.PHONY: install.hdr
install.hdr: $(INTERFACE_HEADERS:%=%_installhdr)
# You need to install the interface header files only if you are going to
# compile programs that use the Netpbm libraries.  Alternatively, you may
# prefer not to "install" them, but just to access the Netpbm source
# directory when you compile your programs.

.PHONY: $(INTERFACE_HEADERS:%=%_installhdr)

$(INTERFACE_HEADERS:%=%_installhdr): $(PKGDIR)/include/netpbm
	$(INSTALL) -c -m $(INSTALL_PERM_HDR) \
	  $(SRCDIR)/lib/$(@:%_installhdr=%) $(PKGDIR)/include/netpbm/

.PHONY: install.staticlib
install.staticlib: $(PKGDIR)/staticlink
	$(INSTALL) -c -m $(INSTALL_PERM_LIBS) libnetpbm.$(STATICLIBSUFFIX) \
	  $(PKGDIR)/staticlink

# Install a shared library stub -- the ".so" file used at link time to
# prepare a program for dynamically linking a library at run time 
.PHONY: install.sharedlibstub
install.sharedlibstub: $(PKGDIR)/sharedlink
ifeq ($(NETPBMLIBTYPE),unixshared)
# install the link-time (.so) links to the runtime libraries
	cd $(PKGDIR)/sharedlink ; \
          rm -f libnetpbm.$(NETPBMLIBSUFFIX); \
          $(SYMLINK) ../lib/libnetpbm.$(NETPBMLIBSUFFIX).$(MAJ) \
            libnetpbm.$(NETPBMLIBSUFFIX)
endif
ifeq ($(NETPBMLIBTYPE),dll)
	$(INSTALL) -c -m $(INSTALL_PERM_LIBS) libnetpbm.dll.a \
	  $(PKGDIR)/sharedlink
endif
ifeq ($(NETPBMLIBTYPE),dylib)
	cd $(PKGDIR)/sharedlink/ ; \
          rm -f libnetpbm.dylib; \
	$(SYMLINK) ../lib/libnetpbm.$(MAJ).$(MIN).dylib libnetpbm.dylib
endif

distclean clean: localclean

.PHONY: localclean
localclean:
	rm -f compile.h

FORCE:

=== other/Makefile ===
ifeq ($(SRCDIR)x,x)
  SRCDIR = $(CURDIR)/..
  BUILDDIR = $(SRCDIR)
endif
SUBDIR = other
VPATH=.:$(SRCDIR)/$(SUBDIR)

include $(BUILDDIR)/config.mk

SUBDIRS = pamx

EXTERN_INCLUDES =
ifneq ($(LINUXSVGALIB),NONE)
  ifneq ($(LINUXSVGAHDR_DIR),)
    EXTERN_INCLUDES += -I$(LINUXSVGAHDR_DIR)
  endif
endif

# We tend to separate out the build targets so that we don't have
# any more dependencies for a given target than it really needs.
# That way, if there is a problem with a dependency, we can still
# successfully build all the stuff that doesn't depend upon it.
# This package is so big, it's useful even when some parts won't 
# build.

PORTBINARIES = pamarith pambayer pamchannel pamdepth \
	pamendian pamfix pamlookup pampick pamsplit \
	pamstack pamsummcol pamunlookup pamvalidate pnmcolormap \
	ppmdcfont ppmddumpfont ppmdmkfont 

ifneq ($(DONT_HAVE_PROCESS_MGMT),Y)
  PORTBINARIES += pamexec
endif

ifneq ($(LINUXSVGALIB),NONE)
  PORTBINARIES += ppmsvgalib
endif

BINARIES = $(PORTBINARIES)

SCRIPTS = ppmtomap pamfixtrunc

OBJECTS = $(BINARIES:%=%.o)

# We don't include programs that have special library dependencies in the
# merge scheme, because we don't want those dependencies to prevent us
# from building all the other programs.

MERGEBINARIES = $(BINARIES)
MERGE_OBJECTS = $(MERGEBINARIES:%=%.o2)

HAVE_MERGE_COMPAT=YES

.PHONY: all
all: $(BINARIES) $(SUBDIRS:%=%/all)

include $(SRCDIR)/common.mk

ppmsvgalib: LDFLAGS_TARGET = $(shell $(LIBOPT) $(LINUXSVGALIB))

install.bin install.merge: install.bin.local
.PHONY: install.bin.local
install.bin.local: $(PKGDIR)/bin
# Remember that $(SYMLINK) might just be a copy command.
# In July 2002, pamarith replaced pnmarith
	cd $(PKGDIR)/bin ; \
	  rm -f pnmarith$(EXE) ; \
	  $(SYMLINK) pamarith$(EXE) pnmarith$(EXE)
# In December 2005, pamsplit replaced pnmsplit
	cd $(PKGDIR)/bin ; \
	  rm -f pnmsplit$(EXE) ; \
	  $(SYMLINK) pamsplit$(EXE) pnmsplit$(EXE)
# In February 2006, pamdepth replaced pnmdepth
	cd $(PKGDIR)/bin ; \
	  rm -f pnmdepth$(EXE) ; \
	  $(SYMLINK) pamdepth$(EXE) pnmdepth$(EXE)

mergecomptrylist:
	cat /dev/null >$@
	echo "TRY(\"pnmarith\", main_pamarith);" >>$@
	echo "TRY(\"pnmsplit\", main_pamsplit);" >>$@
	echo "TRY(\"pnmdepth\", main_pamdepth);" >>$@

FORCE:

=== urt/Makefile ===
ifeq ($(SRCDIR)x,x)
  SRCDIR = $(CURDIR)/..
  BUILDDIR = $(SRCDIR)
endif
SUBDIR = urt
VPATH=.:$(SRCDIR)/$(SUBDIR)

default: all

include $(BUILDDIR)/config.mk

LIBOBJECTS = Runput.o cmd_name.o \
	rle_addhist.o rle_getcom.o rle_getrow.o rle_getskip.o \
	rle_global.o rle_hdr.o rle_open_f.o rle_putcom.o rle_putrow.o \
	rle_row_alc.o \
	vaxshort.o     

MERGE_OBJECTS =

OMIT_URT_RULE = 1
include $(SRCDIR)/common.mk

all: librle.a

librle.a: $(LIBOBJECTS)
	rm -f $@
	$(AR) rc $@ $^
	$(RANLIB) $@

# Rule for objects.
$(LIBOBJECTS): %.o: %.c importinc
	$(CC) -c $(INCLUDES) -o $@ $< $(CFLAGS_ALL)

BINARIES =
SCRIPTS =

=== converter/ppm/Makefile ===
ifeq ($(SRCDIR)x,x)
  SRCDIR = $(CURDIR)/../..
  BUILDDIR = $(SRCDIR)
endif
SUBDIR = converter/ppm
VPATH=.:$(SRCDIR)/$(SUBDIR)

include $(BUILDDIR)/config.mk

SUBDIRS = hpcdtoppm ppmtompeg

PORTBINARIES =	411toppm eyuvtoppm gouldtoppm ilbmtoppm imgtoppm \
		leaftoppm mtvtoppm neotoppm \
		pcxtoppm pc1toppm pi1toppm picttoppm pjtoppm \
		ppmtoacad ppmtoapplevol ppmtoarbtxt ppmtoascii \
		ppmtobmp ppmtoeyuv ppmtogif ppmtoicr ppmtoilbm \
		ppmtoleaf ppmtolj ppmtomitsu ppmtoneo \
		ppmtopcx ppmtopi1 ppmtopict ppmtopj \
		ppmtopjxl ppmtoppm ppmtopuzz ppmtorgb3 \
		ppmtosixel ppmtospu ppmtoterm \
		ppmtowinicon ppmtoxpm ppmtoyuv ppmtoyuvsplit \
		qrttoppm rawtoppm rgb3toppm spctoppm \
		sputoppm tgatoppm winicontoppm ximtoppm xpmtoppm xvminitoppm \
		yuvsplittoppm yuvtoppm 

MATHBINARIES = sldtoppm 

# We don't build vidtoppm, because it requires special libraries and there is
# no known requirement for vidtoppm.


MERGEBINARIES = $(PORTBINARIES) $(MATHBINARIES)
NOMERGEBINARIES =

BINARIES = $(MERGEBINARIES) $(NOMERGEBINARIES) 

DATAFILES = pcxstd.ppm

OBJECTS = $(BINARIES:%=%.o)

MERGE_OBJECTS = $(BINARIES:%=%.o2)

.PHONY: all
all: $(BINARIES) $(SUBDIRS:%=%/all)

include $(SRCDIR)/common.mk

ppmtobmp.o ppmtobmp.o2: bmp.h

tgatoppm.o tgatoppm.o2: tga.h

=== editor/pamflip/Makefile ===
ifeq ($(SRCDIR)x,x)
  SRCDIR = $(CURDIR)/../..
  BUILDDIR = $(SRCDIR)
endif
SUBDIR = editor/pamflip
VPATH=.:$(SRCDIR)/$(SUBDIR)

default: all

include $(BUILDDIR)/config.mk

SUBDIRS =

MERGEBINARIES = pamflip

PORTBINARIES = pamflip

BINARIES = $(PORTBINARIES)

SCRIPTS =

ADDL_OBJECTS = pamflip_sse.o

OBJECTS = pamflip.o $(ADDL_OBJECTS)

MERGE_OBJECTS = $(OBJECTS:%.o=%.o2)

include $(SRCDIR)/common.mk

.PHONY: all
all: $(BINARIES) $(SUBDIRS:%=%/all)

pamflip_sse.o pamflip_sse.o2: CFLAGS_TARGET = $(CFLAGS_SSE)
pamflip.o pamflip.o2: CFLAGS_TARGET = $(CFLAGS_SSE)

pamflip:%:%.o $(ADDL_OBJECTS)

=== other/pamx/Makefile ===
ifeq ($(SRCDIR)x,x)
  SRCDIR = $(CURDIR)/../..
  BUILDDIR = $(SRCDIR)
endif
SUBDIR = other/pamx
VPATH=.:$(SRCDIR)/$(SUBDIR)

include $(BUILDDIR)/config.mk

EXTERN_INCLUDE =

TEST_PKGCONFIG_X11 := \
  if $(PKG_CONFIG) x11 --exists; then echo exists; fi

ifeq ($(shell $(TEST_PKGCONFIG_X11)),)
  # Pkg-config has never heard of X11, or doesn't even exist

  ifneq ($(X11LIB),NONE)
    HAVE_X11LIB = Y
    ifneq ($(X11HDR_DIR)x,x)
      EXTERN_INCLUDES += -I$(X11HDR_DIR)
    endif
  endif
else
  HAVE_X11LIB = Y
  X11LIB = $(shell $(PKG_CONFIG) x11 --libs)
  EXTERN_INCLUDES += $(shell $(PKG_CONFIG) x11 --cflags)
endif

ifeq ($(HAVE_X11LIB),Y)
  PORTBINARIES += pamx

  EXTRA_OBJECTS = \
	  image.o \
	  send.o \
	  window.o \

endif

BINARIES = $(PORTBINARIES)

OBJECTS = $(BINARIES:%=%.o) $(EXTRA_OBJECTS)

MERGE_OBJECTS = $(BINARIES:%=%.o2) $(EXTRA_OBJECTS)

MERGEBINARIES = $(BINARIES)

all: $(BINARIES)

include $(SRCDIR)/common.mk

ifeq ($(shell $(TEST_PKGCONFIG_X11)),)
  # Pkg-config has never heard of X11, or doesn't even exist
  X11_LIBOPTS = $(shell $(LIBOPT) $(LIBOPTR) $(X11LIB))
else
  X11_LIBOPTS = $(shell $(PKG_CONFIG) x11 --libs)
endif

pamx: image.o send.o window.o
pamx: ADDL_OBJECTS = image.o send.o window.o
pamx: LDFLAGS_TARGET = $(X11_LIBOPTS)

=== debian/changelog ===
netpbm-free (2:11.12.00-1) unstable; urgency=low

  * New upstream version.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 28 Sep 2025 13:55:23 +0200

=== debian/watch ===
version=4

# opts="mode=svn,pgpmode=none" \
# https://svn.code.sf.net/p/netpbm/code/release_number/ \
#   (\d[\d.]+)/

opts="mode=svn,pgpmode=none,uversionmangle=s/.*/11.12.00/" \
 https://svn.code.sf.net/p/netpbm/code/advanced/ \
 HEAD ignore

# https://sf.net/netpbm/netpbm-?([\w+\d+\.]+|\d+)\.tgz

# userguide is unversioned
opts="mode=svn,pgpmode=none,uversionmangle=s/.*/11.12.00/, \
 component=userguide" \
 https://svn.code.sf.net/p/netpbm/code/userguide/ \
 HEAD ignore

## netpbm-free 11.13.00

=== debian/changelog ===
netpbm-free (2:11.13.00-3) unstable; urgency=medium

  * Fix typo in CFLAGS (should read -fno-schedule-insns2)

 -- Andreas Metzler <ametzler@debian.org>  Sat, 03 Jan 2026 18:29:39 +0100

netpbm-free (2:11.13.00-2) unstable; urgency=medium

  * Use -fnoschedule-insns2 instead of -fschedule-insns on arm*. This fixes
    armhf, too.
  * Upload to unstable.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 03 Jan 2026 16:55:54 +0100

netpbm-free (2:11.13.00-1) experimental; urgency=medium

  * Work around #1119850 by building with -fschedule-insns on arm*
  * Revert change to watchfile "also hardcode version in component."
    This broke again, lets use a syntax that works on bookworm.
    This reverts commit 8fc7fcb4688c14ddb844344a33e0db3ab9be66e9.
  * rerun debian/updatewatchfile
  * New upstream version 11.13.00

 -- Andreas Metzler <ametzler@debian.org>  Sat, 03 Jan 2026 13:53:16 +0100

=== debian/watch ===
version=4

# opts="mode=svn,pgpmode=none" \
# https://svn.code.sf.net/p/netpbm/code/release_number/ \
#   (\d[\d.]+)/

opts="mode=svn,pgpmode=none,uversionmangle=s/.*/11.13.00/" \
 https://svn.code.sf.net/p/netpbm/code/advanced/ \
 HEAD ignore

# https://sf.net/netpbm/netpbm-?([\w+\d+\.]+|\d+)\.tgz

# userguide is unversioned
opts="mode=svn, pgpmode=none, \
 component=userguide" \
 https://svn.code.sf.net/p/netpbm/code/userguide/ \
 HEAD ignore

## netpbm-free 11.13.03

=== debian/changelog ===
netpbm-free (2:11.13.03-1) unstable; urgency=medium

  * New upstream version.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 15 Feb 2026 07:41:04 +0100

=== debian/control ===
Source: netpbm-free
Section: graphics
Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders:
 Andreas Metzler <ametzler@debian.org>,
 Steve McIntyre <93sam@debian.org>,
Standards-Version: 4.7.3
Build-Depends:
 debhelper-compat (= 13),
 dpkg-dev (>= 1.22.5),
 flex,
 ghostscript <!nocheck>,
 libjpeg-dev,
 libpng-dev,
 libtiff-dev (>= 4.0.10),
 libx11-dev,
 libxml2-dev,
 pkgconf,
 python3,
 zlib1g-dev,
Vcs-Git: https://salsa.debian.org/debian-phototools-team/netpbm.git
Vcs-Browser: https://salsa.debian.org/debian-phototools-team/netpbm
Homepage: https://netpbm.sourceforge.net/

Package: netpbm
Architecture: any
Multi-Arch: foreign
Depends:
 libnetpbm11t64 (= ${binary:Version}),
 ${misc:Depends},
 ${perl:Depends},
 ${shlibs:Depends},
Recommends:
 ghostscript,
Provides:
 pbmwbmp,
 pnmtopng,
Description: Graphics conversion tools between image formats
 Netpbm is a toolkit for manipulation of graphic images, including
 conversion of images between a variety of different formats. There
 are over 220 separate tools in the package including converters for
 more than 80 graphics formats.

Package: libnetpbm11t64
Replaces:
 libnetpbm11,
Breaks:
 libnetpbm11 (<< ${source:Version}),
Section: libs
Architecture: any
Multi-Arch: same
Provides:
 ${t64:Provides},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Graphics conversion tools shared libraries
 Netpbm is a toolkit for manipulation of graphic images, including
 conversion of images between a variety of different formats. There
 are over 220 separate tools in the package including converters for
 more than 80 graphics formats.
 .
 This package contains the shared libraries used by netpbm.

Package: libnetpbm-dev
Section: libdevel
Architecture: any
Depends:
 libnetpbm11t64 (= ${binary:Version}),
 ${misc:Depends},
Conflicts:
 libnetpbm10-dev,
 libnetpbm11-dev,
 libnetpbm9-dev,
 netpbm-dev,
Replaces:
 libnetpbm11-dev,
Provides:
 libnetpbm11-dev,
 netpbm-dev,
Description: Graphics conversion tools development libraries and header files
 Netpbm is a toolkit for manipulation of graphic images, including
 conversion of images between a variety of different formats. There
 are over 220 separate tools in the package including converters for
 more than 80 graphics formats.
 .
 This development package contains the library and header
 files for the pbm, pgm, pnm, and ppm graphics formats.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_CPPFLAGS_MAINT_APPEND = -DUNDEBUG
export DPKG_GENSYMBOLS_CHECK_LEVEL = 4
export COMPILED_BY=Debian

include ./version.mk
MAJOR=$(NETPBM_MAJOR_RELEASE)
MINOR=$(NETPBM_MINOR_RELEASE)
POINT=$(NETPBM_POINT_RELEASE)

include /usr/share/dpkg/pkg-info.mk
# workaround for #1119850
ifneq (,$(findstring arm,$(DEB_HOST_ARCH)))
	export DEB_CFLAGS_MAINT_APPEND += -fno-schedule-insns2
endif

%:
	dh $@ --no-parallel

override_dh_auto_configure:
	if [ `printf '%02d.%02d.%02d' $(NETPBM_MAJOR_RELEASE) $(NETPBM_MINOR_RELEASE) $(NETPBM_POINT_RELEASE)` != $(DEB_VERSION_UPSTREAM) ] ; then \
		echo debian infrastructure for version $(DEB_VERSION_UPSTREAM) used with upstream version $(NETPBM_MAJOR_RELEASE).$(NETPBM_MINOR_RELEASE).$(NETPBM_POINT_RELEASE) ; exit 1 ; fi
	cp config.mk.in config.mk
	cat debian/config.mk.debian >> config.mk
	echo "CFLAGS = `dpkg-buildflags --get CFLAGS`" >> config.mk
ifeq ($(DEB_HOST_ARCH),amd64)
	echo 'WANT_SSE = Y' >> config.mk
endif
	# Let blhc ignore build utilities using *_FOR_BUILD_*FLAGS
	@echo 'blhc: ignore-line-regexp: .* -o typegen\.o .*'
	@echo 'blhc: ignore-line-regexp: .* -o endiangen\.o .*'
	@echo 'blhc: ignore-line-regexp: .* -o libopt\.o .*'

override_dh_auto_build:
	dh_auto_build
# build the manpages
	mkdir netpbmdoc
	cd netpbmdoc; \
		$(MAKE) USERGUIDE=../userguide/ -f ../buildtools/manpage.mk manpages
	# Fix manual section
	sed -i 's/^\(\.TH "[^"]\+" \)0 /\11 /' netpbmdoc/*.1

override_dh_auto_clean:
	[ ! -f config.mk ] || $(MAKE) distclean
	rm -rf debian/netpbm-test debian/netpbm-test.bak
	rm -rf netpbmdoc

override_dh_auto_install:
	mkdir -p debian/tmp/
	$(MAKE) package PKGDIR=$(CURDIR)/debian/tmp/usr
# install the manpages
	cd netpbmdoc; \
		$(MAKE) USERGUIDE=../userguide/ -f ../buildtools/manpage.mk report
# install pkgconfig
	install -m 0755 -d debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig
	sed -e 's|@INCLUDEDIR@|/usr/include/netpbm|' \
		-e 's|@LINKDIR@|/usr/lib/$(DEB_HOST_MULTIARCH)|' \
		-e 's|@VERSION@|Netpbm $(MAJOR).$(MINOR).$(POINT)|' \
		debian/tmp/usr/pkgconfig_template > debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/netpbm.pc
	mv debian/tmp/usr/lib/libnetpbm.so* \
		debian/tmp/usr/staticlink/libnetpbm.a \
		debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/
	ln -s libnetpbm.so.$(MAJOR) \
		debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libnetpbm.so
	find debian -name "lib*.la" -delete
	rm -rf debian/tmp/usr/sharedlink
	# drop broken command
	rm -vf debian/tmp/usr/bin/pamtojpeg2k netpbmdoc/pamtojpeg2k.1

execute_after_dh_installman:
	# tool manweb does not work due to missing /etc/manweb.conf
	find debian -name "manweb*" -delete

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) check-tree RESULTDIR=$(CURDIR)/debian/netpbm-test
endif

=== debian/watch ===
--- 
+++ 
@@ -4,7 +4,7 @@
 # https://svn.code.sf.net/p/netpbm/code/release_number/ \
 #   (\d[\d.]+)/
 
-opts="mode=svn,pgpmode=none,uversionmangle=s/.*/11.13.00/" \
+opts="mode=svn,pgpmode=none,uversionmangle=s/.*/11.13.03/" \
  https://svn.code.sf.net/p/netpbm/code/advanced/ \
  HEAD ignore

## netpbm-free 19940301.2

=== pgm/Makefile ===
# Makefile for pgm tools.
#
# Copyright (C) 1989, 1991 by Jef Poskanzer.
#
# Permission to use, copy, modify, and distribute this software and its
# documentation for any purpose and without fee is hereby granted, provided
# that the above copyright notice appear in all copies and that both that
# copyright notice and this permission notice appear in supporting
# documentation.  This software is provided "as is" without express or
# implied warranty.

# Default values, usually overridden by top-level Makefile.
#CC =		cc
CC =		gcc
#CC =		gcc -ansi -pedantic -fcombine-regs -fpcc-struct-return
CFLAGS =	-O
#CFLAGS =	-g
#CFLAGS =	-g -O
LDFLAGS =	-s
#LDFLAGS =	
INSTALLBINARIES =	/usr/new/pbm
INSTALLMANUALS1 =	/usr/man/man1
SUFFIXMANUALS1 =	1
INSTALLMANUALS3 =	/usr/man/man3
SUFFIXMANUALS3 =	3
INSTALLMANUALS5 =	/usr/man/man5
SUFFIXMANUALS5 =	5
MANCP =			cp

PBMDIR =	../pbm
INCLUDEPBM =	-I$(PBMDIR)
LIBPBM =	$(PBMDIR)/libpbm.a
DEFPBM =	$(PBMDIR)/pbm.h ../pbmplus.h
DEFLIBPBM =	$(PBMDIR)/libpbm.h

SHELL =		/bin/sh
INCLUDE =	-I.. $(INCLUDEPBM)
ALLCFLAGS =	$(CFLAGS) $(INCLUDE)
LIBPGM =	libpgm.a

PORTBINARIES =	asciitopgm bioradtopgm fstopgm hipstopgm \
		lispmtopgm pbmtopgm pgmbentley pgmenhance pgmhist pgmkernel \
		pgmnoise pgmnorm pgmoil pgmramp pgmtofs pgmtolispm \
		pgmtopbm psidtopgm spottopgm
MATHBINARIES =	pgmcrater pgmedge pgmtexture rawtopgm
BINARIES =	$(PORTBINARIES) $(MATHBINARIES)

OBJECTS =	asciitopgm.o bioradtopgm.o fstopgm.o hipstopgm.o \
		lispmtopgm.o pbmtopgm.o pgmbentley.o pgmenhance.o pgmhist.o pgmkernel.o \
		pgmnoise.o pgmnorm.o pgmoil.o pgmramp.o pgmtofs.o pgmtolispm.o \
		pgmtopbm.o psidtopgm.o spottopgm.o \
		rawtopgm.o pgmcrater.o pgmedge.o pgmtexture.o

MANUALS1 =	$(BINARIES)
MANUALS3 =	libpgm
MANUALS5 =	pgm


#all:		binaries
all:		merge
#install:	install.bin
install:	install.merge


binaries:	$(BINARIES)

install.bin:	binaries
	cd $(INSTALLBINARIES) ; rm -f $(BINARIES)
	cp $(BINARIES) $(INSTALLBINARIES)


merge:		pgmmerge
pgmmerge:	pgmmerge.c $(OBJECTS) $(LIBPGM) $(LIBPBM)
	$(CC) $(ALLCFLAGS) $(LDFLAGS) -o $@ $@.c $(OBJECTS) -lm $(LIBPGM) $(LIBPBM)

install.merge:	install.pgmmerge
install.pgmmerge:	pgmmerge
	cd $(INSTALLBINARIES) ; rm -f $(BINARIES)
	cp pgmmerge $(INSTALLBINARIES)
	cd $(INSTALLBINARIES) ; for i in $(BINARIES) ; do ln pgmmerge $$i ; done
	rm -f $(INSTALLBINARIES)/pgmmerge


install.man:
	for i in $(MANUALS1) ; do \
	    rm -f $(INSTALLMANUALS1)/$$i.$(SUFFIXMANUALS1) ; \
	    $(MANCP) $$i.1 $(INSTALLMANUALS1)/$$i.$(SUFFIXMANUALS1) ; \
	done
	for i in $(MANUALS3) ; do \
	    rm -f $(INSTALLMANUALS3)/$$i.$(SUFFIXMANUALS3) ; \
	    $(MANCP) $$i.3 $(INSTALLMANUALS3)/$$i.$(SUFFIXMANUALS3) ; \
	done
	for i in $(MANUALS5) ; do \
	    rm -f $(INSTALLMANUALS5)/$$i.$(SUFFIXMANUALS5) ; \
	    $(MANCP) $$i.5 $(INSTALLMANUALS5)/$$i.$(SUFFIXMANUALS5) ; \
	done


# Rule for plain programs.
$(PORTBINARIES):	pgm.h $(DEFPBM) $(LIBPGM) $(LIBPBM)
	$(CC) $(ALLCFLAGS) $(LDFLAGS) -o $@ $@.c $(LIBPGM) $(LIBPBM)

# Rule for math-dependent programs.
$(MATHBINARIES):	pgm.h $(DEFPBM) $(LIBPGM) $(LIBPBM)
	$(CC) $(ALLCFLAGS) $(LDFLAGS) -o $@ $@.c -lm $(LIBPGM) $(LIBPBM)

# Rule for objects.
$(OBJECTS):	pgm.h $(DEFPBM)
	$(CC) $(ALLCFLAGS) "-Dmain=$*_main" -c $*.c

# And libraries.
$(LIBPBM):
	cd $(PBMDIR) ; make lib
lib:		$(LIBPGM)
$(LIBPGM):	libpgm1.o libpgm2.o
	-rm -f $(LIBPGM)
	ar rc $(LIBPGM) libpgm1.o libpgm2.o
	-ranlib $(LIBPGM)

libpgm1.o:	pgm.h $(DEFPBM) libpgm.h libpgm1.c
	$(CC) $(ALLCFLAGS) -c libpgm1.c
libpgm2.o:	pgm.h $(DEFPBM) libpgm.h libpgm2.c $(DEFLIBPBM)
	$(CC) $(ALLCFLAGS) -c libpgm2.c

# Other dependencies.
bioradtopgm bioradtopgm.o:	bioradtopgm.c
asciitopgm asciitopgm.o:	asciitopgm.c
fstopgm fstopgm.o:		fstopgm.c
hipstopgm hipstopgm.o:		hipstopgm.c
lispmtopgm lispmtopgm.o:	lispmtopgm.c
pbmtopgm pbmtopgm.o:		pbmtopgm.c
pgmbentley pgmbentley.o:	pgmbentley.c
pgmcrater pgmcrater.o:		pgmcrater.c
pgmedge pgmedge.o:		pgmedge.c
pgmenhance pgmenhance.o:	pgmenhance.c
pgmhist pgmhist.o:		pgmhist.c
pgmkernel pgmkernel.o:		pgmkernel.c
pgmnoise pgmnoise.o:		pgmnoise.c
pgmnorm pgmnorm.o:		pgmnorm.c
pgmoil pgmoil.o:		pgmoil.c
pgmramp pgmramp.o:		pgmramp.c
pgmtexture pgmtexture.o:	pgmtexture.c
pgmtopbm pgmtopbm.o:		pgmtopbm.c dithers.h $(DEFPBM)
pgmtofs pgmtofs.o:		pgmtofs.c
pgmtolispm pgmtolispm.o:	pgmtolispm.c
psidtopgm psidtopgm.o:		psidtopgm.c
rawtopgm rawtopgm.o:		rawtopgm.c
spottopgm spottopgm.o:		spottopgm.c

clean:
	-rm -f *.o *.a *.cat *~ core $(BINARIES) pgmmerge
